#!/usr/bin/env python
# # -*- coding:iso-8859-1  -*-
#
# Code utilise pour l'article http://ptaff.ca/routes/
#
# Copyright (C) 2006 Miguel Tremblay
#
#  Questions or bugs report: miguel.tremblay@ptaff.ca
#
#
# Code contributed by:
#  Miguel Tremblay - ptaff.ca
#
########################################################################
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
#


"""
 Name:	       climato_rain.py
 Description: Ouvre le fichier contenant les precipitations liquides
   pour une station et fait une climatologie pour chacun des mois.
 
 Notes: 

 Author: Miguel Tremblay
 Date: 15 mai 2006
 
"""


import sys

def main(sFichierTexte, sOutput):

    # Ouverture et lecture du fichier texte
    fichier_texte = open(sFichierTexte, 'r')
    # Les 2 premieres lignes contiennent l'entete
    lYearPrecip = fichier_texte.readlines()[2:]

    dDict = {}
    for i in range(1,13):
        dDict[i] = []
        
    for sLine in lYearPrecip:
        lYearMonth = sLine.split(',')        
        for i in range(1,13):
            fCurrentValue = float(lYearMonth[i])
            # Valeur sous zero sont invalides
            if fCurrentValue > 0:
                dDict[i].append(fCurrentValue)
                
    # Calculons la moyenne
    dPrecipMoyenne = {}
    for i in range(1,13):
        if len(dDict[i]) == 0:
            dPrecipMoyenne[i] = 0
        else:
            dPrecipMoyenne[i] = sum(dDict[i])/len(dDict[i])

    # Ecriture du resultat
    fichier_output = open(sOutput, 'w')
    for i in range(1,13):
        sLine = str(i) + ',' + str(dPrecipMoyenne[i]) + '\n'
        fichier_output.write(sLine)
    

if __name__ == "__main__":


    if len(sys.argv) < 3:
        print "Usage climato_rain.py fichier.txt output.txt"
        sys.exit(1)

    sFichierTexte = sys.argv[1]
    sOutput = sys.argv[2]
    main(sFichierTexte, sOutput)



