#!/usr/bin/python
# -*- coding:iso-8859-1  -*-
#
# Code utilise pour l'article http://ptaff.ca/routes/
#
# Copyright (C) 2006 Miguel Tremblay
#
#  Questions or bugs report: miguel.tremblay@ptaff.ca
#
#
# Code contributed by:
#  Miguel Tremblay - ptaff.ca
#
########################################################################
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
#


"""
 Name:	      combine_years_month.py
 Description: Prend un fichier csv avec des donnees de la forme:
  YYYY-MM, nombre_de_degel, nombre_de_degel_avec_pluie, nombre_observations
  et combine les annees ensemble pour avoir un resultat/mois.

       Input: station_nbr_degel.txt
       Output: station_nbr_degel_month.txt
 
 Notes: 

 Author: Miguel Tremblay
 Date: 20 mai 2006
"""

import sys

sHeader = 'MM, nbr_de_degel, nbr_degel_avec_pluie, nbr_observations\n'

def main(sFilename):

    # Ouvrir le fichier 
    sOriginalFile = open(sFilename, 'r')

    # First line is the header
    lLineInFile = sOriginalFile.readlines()[1:]

    
    dMonthNbrDegel = {}
    dMonthNbrDegelPluie = {}
    dMonthNbrObs = {}
    lDictionnary = [dMonthNbrDegel, dMonthNbrDegelPluie, dMonthNbrObs]
    for dDictionnary in lDictionnary:
        for i in range(1,13):
            dDictionnary[i] = 0

    # Parse the data
    for sLine in lLineInFile:
        lLine = sLine.split(',')
        nMonth = int(lLine[0].split('-')[1])
        for i in range(0,3):
            nPreviousNbr = lDictionnary[i][nMonth]
            lDictionnary[i][nMonth] = nPreviousNbr + int(lLine[i+1])

    # Ecrire les lignes
    lLignesOutput = []
    for i in range(1,13):
        sLine = str(i)
        if len(sLine) == 1:
            sLine = '0' + sLine
        for dDictionnary in lDictionnary:
            sLine = sLine + ',' + str(dDictionnary[i])
        sLine = sLine + '\n'
        lLignesOutput.append(sLine)

    # Ecrire le fichier
    lLignesOutput.sort()
    lLignesOutput = [sHeader] + lLignesOutput
    sOutput = sFilename[:-4] + '_month.txt'
    print 'Writing:', sOutput
    file_output = open(sOutput, 'w')
    file_output.writelines(lLignesOutput)
    

if __name__ == "__main__":

    lArgs = ['']*1

    if len(sys.argv) < 2:
        print "Usage combine_years_month.py nombre_degel.txt"
        sys.exit(1)
        

    sFilename = sys.argv[1]

    
    main(sFilename)



